local td = {}
local tr, headpos, dmgpos, ent, d, speed, wep, p, sp1, sp2, sp3
local No -- use existing tables instead of creating new ones every time

function _R.Entity:FireBulletsEx(num, pos, dir, dmg, spread, force, t, pen, abd)
	if not t then
		t = CurTime()
	end
	
	if not abd then -- abd stands for "additional bullet drop"
		abd = 0
	end
	
	if not util.IsInWorld(pos) then -- Eliminate the bullet if it went outside the map
		print("Bullet went through world, eliminating bullet")
		return
	end
	
	wep = self:GetActiveWeapon()

	speed = (wep.MuzVel or 512) / 1.7877 -- slightly decrease muzzle velocity to make sure it's identical to real life
	sp1 = math.Rand(-spread, spread) * 0.75
	sp2 = math.Rand(-spread, spread) * 0.75
	sp3 = math.Rand(-spread, 0) * 0.75
	
	dir.x = dir.x + sp1
	dir.y = dir.y + sp2
	dir.z = dir.z + sp3
	spread = 0
	
	timer.Simple(0, function()
		td.start = pos
		td.endpos = td.start + dir * speed
		td.filter = self
		
		tr = util.TraceLine(td)
		abd = abd + 0.05
		
		if tr.Hit then
			ent = tr.Entity
			print("hit entity ", ent:GetClass())
			
			if SERVER then
				if tr.HitWorld or ent and ent:GetClass():find("prop_") and not pen then
					td.start = tr.HitPos + dir * 20
					td.endpos = td.start + dir * 1
					td.filter = self
					
					tr = util.TraceLine(td)
					
					self:FireBullets({Num = num, Src = pos, Dir = dir, Spread = No, Tracer = 0, Force = dmg, Damage = dmg, Callback = function(att, trace, dmg)
						if wep:GetDTInt(2) == 1 then
							if ValidEntity(trace.Entity) then
								trace.Entity:Ignite(6)
							end
							
							ParticleEffect("cstm_incendiary_hit", trace.HitPos, trace.HitNormal:Angle(), nil)
						end
					end})
					
					if not tr.Hit then
						print("Penetrated surface")
						tr.HitPos.z = tr.HitPos.z - (0.1 + abd)
						self:FireBulletsEx(num, tr.HitPos, dir, dmg, math.Rand(-0.1, 0.1), force, t, true, abd)
					end
				else
					self:FireBullets({Num = num, Src = pos, Dir = dir, Spread = No, Tracer = 0, Force = dmg, Damage = dmg, Callback = function(att, trace, dmg)
						if wep:GetDTInt(2) == 1 then
							if ValidEntity(trace.Entity) then
								trace.Entity:Ignite(6)
							end
							
							ParticleEffect("cstm_incendiary_hit", trace.HitPos, trace.HitNormal:Angle(), nil)
						end
					end})
				end
			end
		else
			tr.HitPos.z = tr.HitPos.z - (0.1 + abd)
			print("retracing bullet...", tr.HitPos.z, abd)
			self:FireBulletsEx(num, tr.HitPos, dir, dmg, spread, force, t, pen, abd)
		end
	end)
end
