if SERVER then
	AddCSLuaFile("shared.lua")
end

if CLIENT then
    SWEP.AcogGlass = Material( "models/wystan/attachments/acog/lense" )
    SWEP.AcogRT = GetRenderTarget( "acog_glass_rt", 512, 512, false )
    SWEP.AcogGlass:SetMaterialTexture( "$basetexture", SWEP.AcogRT )
end

function SWEP:Initialize()
 
    // other initialize code goes here
 
    if CLIENT then
     
        self:CreateModels(self.VElements) // create viewmodels
        self:CreateModels(self.WElements) // create worldmodels
         
        // init view model bone build function
        self.BuildViewModelBones = function( s )
            if LocalPlayer():GetActiveWeapon() == self and self.ViewModelBoneMods then
                for k, v in pairs( self.ViewModelBoneMods ) do
                    local bone = s:LookupBone(k)
                    if (!bone) then continue end
                    local m = s:GetBoneMatrix(bone)
                    if (!m) then continue end
                    m:Scale(v.scale)
                    m:Rotate(v.angle)
                    m:Translate(v.pos)
                    s:SetBoneMatrix(bone, m)
                end
            end
        end
         
    end
 
end
 
 
function SWEP:OnRemove()
     
    // other onremove code goes here
     
    if CLIENT then
        self:RemoveModels()
    end
     
end
 
if CLIENT then
	local vm, v, model, sprite, pos, ang, drawpos, lt, fw, aim, dir, td, trace, ply, old, ang, ang2, CamData, m, name, params, tocheck, dist, entry, dir, mdl, mat, size, dt3, dist, scale, EA, delta, FT
	local ScopeTexture = surface.GetTextureID("gcellmats/scope_rifle2")
	local Dot = Material("sprites/aim_reticule")
	local Ret = Material("sprites/eotech_reddot")
	local Tri = Material("sprites/acog_tri")
	
	local Laser = Material("effects/redlaser1")
	local LaserDot = Material("effects/brightglow_y")
 
    SWEP.vRenderOrder = nil
	
    function SWEP:ViewModelDrawn()
        vm = self.Owner:GetViewModel()
        if !ValidEntity(vm) then return end
         
        if (!self.VElements) then return end
         
        if vm.BuildBonePositions ~= self.BuildViewModelBones then
            vm.BuildBonePositions = self.BuildViewModelBones
        end
 
        if (self.ShowViewModel == nil or self.ShowViewModel) then
            vm:SetColor(255,255,255,255)
        else
            // we set the alpha to 1 instead of 0 because else ViewModelDrawn stops being called
            vm:SetColor(255,255,255,1)
        end
		
		if self.OldDelta then
			FT = FrameTime()
			EA = self.Owner:EyeAngles()
			delta = Angle(EA.p, EA.y, 0) - self.OldDelta
				
			self.OldDelta = Angle(EA.p, EA.y, 0)
			self.AngleDelta = LerpAngle(FT * 15, self.AngleDelta, delta)
			self.AngleDelta.y = math.Clamp(self.AngleDelta.y, -15, 15)
		end
         
        if (!self.vRenderOrder) then
            // we build a render order because sprites need to be drawn after models
            self.vRenderOrder = {}
 
            for k, v in pairs( self.VElements ) do
                if (v.type == "Model") then
                    table.insert(self.vRenderOrder, 1, k)
                elseif (v.type == "Sprite" or v.type == "Quad") then
                    table.insert(self.vRenderOrder, k)
                end
            end
             
        end
		
		aim = self.Owner:EyeAngles()
		dt3 = self:GetDTInt(3)
 
        for k, name in ipairs( self.vRenderOrder ) do
			v = self.VElements[name]
            if (!v) then self.vRenderOrder = nil break end
         
            model = v.modelEnt
            sprite = v.spriteMaterial
             
            if (!v.bone) then continue end
             
            pos, ang = self:GetBoneOrientation( self.VElements, v, vm )
             
            if (!pos) then continue end
             
            if (v.type == "Model" and ValidEntity(model)) then
				model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
				ang:RotateAroundAxis(ang:Up(), v.angle.y)
				ang:RotateAroundAxis(ang:Right(), v.angle.p)
				ang:RotateAroundAxis(ang:Forward(), v.angle.r)
 
				model:SetAngles(ang)
				model:SetModelScale(v.size)
				 
				if (v.material == "") then
					model:SetMaterial("")
				elseif (model:GetMaterial() != v.material) then
					model:SetMaterial( v.material )
				end
				 
				if (v.skin and v.skin != model:GetSkin()) then
					model:SetSkin(v.skin)
				end
				 
				if (v.bodygroup) then
					for k, v in pairs( v.bodygroup ) do
						if (model:GetBodygroup(k) != v) then
							model:SetBodygroup(k, v)
						end
					end
				end
				 
				if (v.surpresslightning) then
					render.SuppressEngineLighting(true)
				end
				
				mdl = model:GetModel()
				
				if (mdl == "models/wystan/attachments/aimpoint.mdl" or mdl == "models/wystan/attachments/2octorrds.mdl" or mdl == "models/wystan/attachments/2otech557sight.mdl" or mdl == "models/wystan/attachments/2cog.mdl") and v.color.a == 255 then
					if dt3 == 1 then
						mat = Dot
						size = 0.0375
						dist = self.AimpointDist and self.AimpointDist or 10
						
						if mdl == "models/wystan/attachments/2otech557sight.mdl" then
							mat = Ret
							size = 0.375
							dist = self.EoTechDist and self.EoTechDist or 10
						elseif mdl == "models/wystan/attachments/2cog.mdl" then
							mat = Tri
							size = 0.25
							dist = self.ACOGDist and self.ACOGDist or 7
						end
					else
						mat = Dot
						size = 0.0375
						dist = 20
						
						if mdl == "models/wystan/attachments/2otech557sight.mdl" then
							mat = Ret
							size = 0.375
						elseif mdl == "models/wystan/attachments/2cog.mdl" then
							mat = Tri
							size = 0.25
						end
					end
					
					dir = EyeAngles():Forward()
					
					render.ClearStencil()
					render.SetStencilEnable(true)
							
					render.SetStencilFailOperation(STENCILOPERATION_KEEP)
					render.SetStencilZFailOperation(STENCILOPERATION_KEEP)
					render.SetStencilPassOperation(STENCILOPERATION_REPLACE)
					render.SetStencilCompareFunction(STENCILCOMPARISONFUNCTION_ALWAYS)
					render.SetStencilReferenceValue(1)
					
					render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
					render.SetBlend(v.color.a/255)
					model:DrawModel()
					render.SetBlend(1)
					render.SetColorModulation(1, 1, 1)
					 
					if (v.surpresslightning) then
						render.SuppressEngineLighting(false)
					end
					
					render.SetStencilReferenceValue(2)
					render.SetStencilCompareFunction( STENCILCOMPARISONFUNCTION_EQUAL )
					render.SetStencilPassOperation( STENCILOPERATION_REPLACE )
					render.SetStencilReferenceValue(1)
					
					scale = 10 / dist
					size = size / scale
					render.SetMaterial(mat)
					render.DrawSprite(EyePos() + dir * dist, size, size, Color(255, 255, 255, 255))
					render.SetStencilEnable( false )
				else
					render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
					render.SetBlend(v.color.a/255)
					model:DrawModel()
					render.SetBlend(1)
					render.SetColorModulation(1, 1, 1)
					 
					if (v.surpresslightning) then
						render.SuppressEngineLighting(false)
					end
				end
                 
            elseif (v.type == "Sprite" and sprite) then
                 
                drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
                 
            elseif (v.type == "Quad" and v.draw_func) then
                 
                drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
                 
                cam.Start3D2D(drawpos, ang, v.size)
                    v.draw_func( self )
                cam.End3D2D()
 
            end
             
        end
		
		if self.VElements and self.VElements["laser"] and self.VElements["laser"].color.a == 255 then
			lt = self.LaserTune
			fw = self.VElements["laser"].modelEnt:GetAngles()
			pos = self.VElements["laser"].modelEnt:GetPos()
			pos = pos + aim:Right() * lt.PosRight + aim:Up() * lt.PosUp + aim:Forward() * lt.PosForward
			fw:RotateAroundAxis(fw:Right(), lt.AngUp)
			fw:RotateAroundAxis(fw:Up(), lt.AngRight)
			fw:RotateAroundAxis(fw:Forward(), lt.AngForward)
			fw = fw:Forward()
			
			if dt3 == 1 then
				dir = (aim + Angle(self.AngleDelta.p / 3, self.AngleDelta.y / 3, 0) + self.Owner:GetPunchAngle()):Forward()
			else
				dir = fw
			end
			
			td = {}
			td.start = pos
			td.endpos = td.start + dir * 8192
			td.filter = self.Owner
			
			trace = util.TraceLine(td)
			
			render.SetMaterial(Laser)
			render.DrawBeam(pos + dir, trace.HitPos, 0.5, 0.5, 0.5, Color(255, 255, 255, 255))
			
			render.SetMaterial(LaserDot)
			render.DrawSprite(trace.HitPos, 2, 2, Color(255, 0, 0, 255))
		end
		
        old = nil
       
	   	if self.Weapon.VElements and self.Weapon.VElements["acog"] and self.Weapon.VElements["acog"].color.a == 255 and GetConVarNumber("cstm_oldacog") <= 0 then
			old = render.GetRenderTarget( )
			ply = LocalPlayer()
			ang = self.Weapon.VElements["acog"].modelEnt:GetAngles()
			ang2 = ang - aim
			ang:RotateAroundAxis(ang:Up(), -ang2.y)
				
			CamData = {}
			CamData.angles = ang
			CamData.origin = ply:GetShootPos()
			CamData.x = 0
			CamData.y = 0
			CamData.w = 512
			CamData.h = 512
			CamData.fov = 4
			CamData.drawviewmodel = false
			CamData.drawhud = false
			render.SetRenderTarget( self.AcogRT )
			render.SetViewPort( 0, 0, 512, 512 )
		
			cam.Start2D()
				render.RenderView(CamData)
				//surface.SetDrawColor(255, 255, 255, 255) -- for GMod 13
				//surface.SetTexture(ScopeTexture)
				//surface.DrawTexturedRect(-256, -256, 1024, 1024)
			cam.End2D()
			
			render.SetViewPort( 0, 0, ScrW( ), ScrH( ) )
			render.SetRenderTarget( old )
		end
    end
 
    SWEP.wRenderOrder = nil
	
    function SWEP:DrawWorldModel()
         
        if (self.ShowWorldModel == nil or self.ShowWorldModel) then
            self:DrawModel()
		else
			self:DrawShadow(false)
        end
         
        if (!self.WElements) then return end
         
        if (!self.wRenderOrder) then
 
            self.wRenderOrder = {}
 
            for k, v in pairs( self.WElements ) do
                if (v.type == "Model") then
                    table.insert(self.wRenderOrder, 1, k)
                elseif (v.type == "Sprite" or v.type == "Quad") then
                    table.insert(self.wRenderOrder, k)
                end
            end
 
        end
         
        if (ValidEntity(self.Owner)) then
            bone_ent = self.Owner
        else
            // when the weapon is dropped
            bone_ent = self
        end
         
        for k, name in pairs( self.wRenderOrder ) do
         
            entry = self.WElements[name]
            if (!entry) then self.wRenderOrder = nil break end
             
            pos, ang = nil, nil
             
            if (entry.bone) then
                pos, ang = self:GetBoneOrientation( self.WElements, entry, bone_ent )
            else
                pos, ang = self:GetBoneOrientation( self.WElements, entry, bone_ent, "ValveBiped.Bip01_R_Hand" )
            end
             
            if (!pos) then continue end
             
            model = entry.modelEnt
            sprite = entry.spriteMaterial
             
            if (entry.type == "Model" and ValidEntity(model)) then
 
                model:SetPos(pos + ang:Forward() * entry.pos.x + ang:Right() * entry.pos.y + ang:Up() * entry.pos.z )
                ang:RotateAroundAxis(ang:Up(), entry.angle.y)
                ang:RotateAroundAxis(ang:Right(), entry.angle.p)
                ang:RotateAroundAxis(ang:Forward(), entry.angle.r)
 
                model:SetAngles(ang)
                model:SetModelScale(entry.size)
                 
                if (entry.material == "") then
                    model:SetMaterial("")
                elseif (model:GetMaterial() != entry.material) then
                    model:SetMaterial( entry.material )
                end
                 
                if (entry.skin and entry.skin != model:GetSkin()) then
                    model:SetSkin(entry.skin)
                end
                 
                if (entry.bodygroup) then
                    for k, entry in pairs( entry.bodygroup ) do
                        if (model:GetBodygroup(k) != entry) then
                            model:SetBodygroup(k, entry)
                        end
                    end
                end
                 
                if (entry.surpresslightning) then
                    render.SuppressEngineLighting(true)
                end
                 
                render.SetColorModulation(entry.color.r/255, entry.color.g/255, entry.color.b/255)
                render.SetBlend(entry.color.a/255)
                model:DrawModel()
                render.SetBlend(1)
                render.SetColorModulation(1, 1, 1)
                 
                if (entry.surpresslightning) then
                    render.SuppressEngineLighting(false)
                end
                 
            elseif (entry.type == "Sprite" and sprite) then
                 
                drawpos = pos + ang:Forward() * entry.pos.x + ang:Right() * entry.pos.y + ang:Up() * entry.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, entry.size.x, entry.size.y, entry.color)
                 
            elseif (entry.type == "Quad" and entry.draw_func) then
                 
                drawpos = pos + ang:Forward() * entry.pos.x + ang:Right() * entry.pos.y + ang:Up() * entry.pos.z
                ang:RotateAroundAxis(ang:Up(), entry.angle.y)
                ang:RotateAroundAxis(ang:Right(), entry.angle.p)
                ang:RotateAroundAxis(ang:Forward(), entry.angle.r)
                 
                cam.Start3D2D(drawpos, ang, entry.size)
                    entry.draw_func( self )
                cam.End3D2D()
 
            end
             
        end
         
    end
	
    function SWEP:GetBoneOrientation( basetab, tab, ent, bone_override )
         
        bone, pos, ang = nil, nil, nil
        if (tab.rel and tab.rel != "") then
             
            v = basetab[tab.rel]
             
            if (!v) then return end
             
            // Technically, if there exists an element with the same name as a bone
            // you can get in an infinite loop. Let's just hope nobody's that stupid.
            pos, ang = self:GetBoneOrientation( basetab, v, ent )
             
            if (!pos) then return end
             
            pos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
            ang:RotateAroundAxis(ang:Up(), v.angle.y)
            ang:RotateAroundAxis(ang:Right(), v.angle.p)
            ang:RotateAroundAxis(ang:Forward(), v.angle.r)
                 
        else
         
            bone = ent:LookupBone(bone_override or tab.bone)
 
            if (!bone) then return end
             
            pos, ang = Vector(0,0,0), Angle(0,0,0)
            m = ent:GetBoneMatrix(bone)
            if (m) then
                pos, ang = m:GetTranslation(), m:GetAngle()
            end
             
            if (ValidEntity(self.Owner) and self.Owner:IsPlayer() and
                ent == self.Owner:GetViewModel() and self.ViewModelFlip) then
                ang.r = -ang.r // Fixes mirrored models
            end
         
        end
         
        return pos, ang
    end
 
    function SWEP:CreateModels( tab )
 
        if (!tab) then return end
 
        // Create the clientside models here because Garry says we can't do it in the render hook
        for k, v in pairs( tab ) do
            if (v.type == "Model" and v.model and v.model != "" and (!ValidEntity(v.modelEnt) or v.createdModel != v.model) and
                    string.find(v.model, ".mdl") and file.Exists ("../"..v.model) ) then
                 
                v.modelEnt = ClientsideModel(v.model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
                if (ValidEntity(v.modelEnt)) then
                    v.modelEnt:SetPos(self:GetPos())
                    v.modelEnt:SetAngles(self:GetAngles())
                    v.modelEnt:SetParent(self)
                    v.modelEnt:SetNoDraw(true)
                    v.createdModel = v.model
                else
                    v.modelEnt = nil
                end
                 
            elseif (v.type == "Sprite" and v.sprite and v.sprite != "" and (!v.spriteMaterial or v.createdSprite != v.sprite)
                and file.Exists ("../materials/"..v.sprite..".vmt")) then
                 
                name = v.sprite.."-"
                params = { ["$basetexture"] = v.sprite }
                // make sure we create a unique name based on the selected options
                tocheck = { "nocull", "additive", "vertexalpha", "vertexcolor", "ignorez" }
                for i, j in pairs( tocheck ) do
                    if (v[j]) then
                        params["$"..j] = 1
                        name = name.."1"
                    else
                        name = name.."0"
                    end
                end
 
                v.createdSprite = v.sprite
                v.spriteMaterial = CreateMaterial(name,"UnlitGeneric",params)
                 
            end
        end
         
    end
 
    function SWEP:OnRemove()
        self:RemoveModels()
    end
 
    function SWEP:RemoveModels()
        if (self.VElements) then
            for k, v in pairs( self.VElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
        if (self.WElements) then
            for k, v in pairs( self.WElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
		
        self.VElements = nil
        self.WElements = nil
    end
 
end